﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Text;
using KeenSoftwareHouse.Library.Extensions;
using MinerWars.CommonLIB.AppCode.Networking;
using MinerWars.CommonLIB.AppCode.ObjectBuilders.SubObjects.SmallShipTools;
using SysUtils.Utils;

namespace MinerWars.CommonLIB.AppCode.ObjectBuilders.SubObjects
{
    //  IMPORTANT: Never change numeric values and never delete any enum item. These numbers are referenced e.g. from database.
    public enum MyMwcObjectBuilder_Blueprint_TypesEnum : ushort
    {
        //P430_A01_PASSAGE_10M = 0,
        //P430_A02_PASSAGE_40M  = 1,
        //P424_A01_PIPE_BASE = 2,
        //P423_A01_PIPE_JUNCTION = 3,
        //P422_A01_PIPE_TURN_90 = 4,
        //P421_A01_PIPE_STRAIGHT_80M = 5,
        //P421_A02_PIPE_STRAIGHT_40M = 6,
        //P421_A03_PIPE_STRAIGHT_10M = 7,
        //P413_G01_JUNCTION_6AXES = 8,
        //P414_G02_ENTRANCE_60M = 9,
        //P410_G01_TURN_90_RIGHT_0M = 10,
        //P411_G01_STRAIGHT_1 = 11,
        //P411_G02_STRAIGHT_2 = 12,
        //P411_G03_STRAIGHT_3 = 13,
        //P411_G04_STRAIGHT_4 = 14,
        //P414_F02_ENTRANCE_60M = 15,
        //P412_F21_TURN_S_UP = 16,
        //P412_F22_TURN_S_LEFT = 17,
        //P412_F23_TURN_S_RIGHT = 18,
        //P412_F24_TURN_S_DOWN = 19,
        //P412_F01_TURN_90_UP_230M = 20,
        //P412_F02_TURN_90_LEFT_230M = 21,
        //P412_F03_TURN_90_RIGHT_230M = 22,
        //P412_F04_TURN_90_DOWN_230M = 23,
        //P411_F01_STRAIGHT_1 = 24,
        //P411_F02_STRAIGHT_2 = 25,
        //P411_F03_STRAIGHT_3 = 26,
        //P414_E01_ENTRANCE_60M = 27,
        //P411_E01_STRAIGHT_1 = 28,
        //P411_E02_STRAIGHT_2 = 29,
        //P411_E03_STRAIGHT_3 = 30,
        //P411_E04_STRAIGHT_4 = 31,
        //P411_E05_STRAIGHT_5 = 32,
        //P415_D01_DOORCASE = 33,
        //P415_D02_DOOR1 = 34,
        //P415_D03_DOOR2_A = 35,
        //P415_D03_DOOR2_B = 36,
        //P413_D01_JUNCTION_T_HORIZONTAL = 37,
        //P413_D03_JUNCTION_X_HORIZONTAL = 38,
        //P414_D01_ENTRANCE_60M = 39,
        //P411_D01_STRAIGHT_10M = 40,
        //P411_D02_STRAIGHT_40M_WITH_HOLE = 41,
        //P411_D03_STRAIGHT_60M = 42,
        //P411_D04_STRAIGHT_120M = 43,
        //P411_D05_STRAIGHT_180M = 44,
        //P415_C01_DOOR1 = 45,
        //P415_C01_DOOR2 = 46,
        //P415_C01_DOOR3 = 47,
        //P415_C01_DOOR4 = 48,
        //P413_C01_JUNCTION_T_HORIZONTAL = 49,
        //P413_C01_JUNCTION_X_HORIZONTAL = 50,
        //P414_C01_ENTRANCE_60M = 51,
        //P411_C01_STRAIGHT_10M = 52,
        //P411_C02_STRAIGHT_40M_WITH_HOLE = 53,
        //P411_C03_STRAIGHT_60M = 54,
        //P411_C04_STRAIGHT_120M = 55,
        //P411_C05_STRAIGHT_180M = 56,
        //P415_B01_DOORCASE = 57,
        //P415_B02_DOOR = 58,
        //P413_B01_JUNCTION_T_HORIZONTAL = 59,
        //P413_B02_JUNCTION_T_VERTICAL = 60,
        //P414_B02_ENTRANCE_60M = 61,
        //P412_B21_TURN_S_UP = 62,
        //P412_B22_TURN_S_LEFT = 63,
        //P412_B23_TURN_S_RIGHT = 64,
        //P412_B24_TURN_S_DOWN = 65,
        //P412_B11_TURN_90_UP_160M = 66,
        //P412_B12_TURN_90_LEFT_160M = 67,
        //P412_B13_TURN_90_RIGHT_160M = 68,
        //P412_B14_TURN_90_DOWN_160M = 69,
        //P412_B01_TURN_90_UP_80M = 70,
        //P412_B02_TURN_90_LEFT_80M = 71,
        //P412_B03_TURN_90_RIGHT_80M = 72,
        //P412_B04_TURN_90_DOWN_80M = 73,
        //P411_B01_STRAIGHT_10M = 74,
        //p411_B02_STRAIGHT_30M_YELLOW = 75,
        //p411_B03_STRAIGHT_320M = 76,
        //p411_B04_STRAIGHT_80M_WITH_SIDE_GRATES = 77,
        //p411_B05_STRAIGHT_80M_WITH_SIDE_OPEN = 78,
        //p411_B06_STRAIGHT_180M_CONCRETE = 79,
        //p411_B06_STRAIGHT_200M = 80,
        //p411_B07_STRAIGHT_180M_BLUE = 81,
        //p411_B09_STRAIGHT_30M_GRAY = 82,
        //p411_B11_STRAIGHT_220M = 83,
        //p411_B12_STRAIGHT_160M_DARK_METAL = 84,
        //p411_B13_STRAIGHT_100M_TUBE_INSIDE = 85,
        //P415_A01_DOORCASE = 86,
        //P415_A02_DOOR = 87,
        //P413_A01_JUNCTION_T_HORIZONTAL = 88,
        //P413_A02_JUNCTION_T_VERTICAL = 89,
        //P414_A01_ENTRANCE_30M = 90,
        //P414_A02_ENTRANCE_60M = 91,
        //P412_A21_TURN_S_UP = 92,
        //P412_A22_TURN_S_LEFT = 93,
        //P412_A23_TURN_S_RIGHT = 94,
        //P412_A24_TURN_S_DOWN = 95,
        //P412_A11_TURN_90_UP_160M = 96,
        //P412_A12_TURN_90_LEFT_160M = 97,
        //P412_A13_TURN_90_RIGHT_160M = 98,
        //P412_A14_TURN_90_DOWN_160M = 99,
        //P412_A01_TURN_90_UP_80M = 100,
        //P412_A02_TURN_90_LEFT_80M = 101,
        //P412_A03_TURN_90_RIGHT_80M = 102,
        //P412_A04_TURN_90_DOWN_80M = 103,
        //P411_A01_STRAIGHT_10M = 104,
        //P411_A02_STRAIGHT_60M_WITH_HOLE = 105,
        //P411_A03_STRAIGHT_120M = 106,
        //P411_A04_STRAIGHT_80M = 107,
        //P411_A05_STRAIGHT_80M_WITH_EXTENSION = 108,
        //P382_E01_BRIDGE5 = 109,
        //P382_D01_BRIDGE4 = 110,
        //P382_C01_BRIDGE3 = 111,
        //P382_B01_BRIDGE2 = 112,
        //P382_A01_BRIDGE1 = 113,
        //P381_C01_BUILDING3 = 114,
        //P381_B01_BUILDING2 = 115,
        //P381_A01_BUILDING1 = 116,
        //P361_A01_SMALL_HANGAR = 117,
        //P362_A01_SHORT_DISTANCE_ANTENNA = 118,
        //P361_A01_LONG_DISTANCE_ANTENNA = 119,
        //P351_A01_WEAPON_MOUNT = 120,
        //P345_A01_REFINERY = 121,
        //P344_A01_CONTAINER_ARM_FILLED = 122,
        //P344_A02_CONTAINER_ARM_EMPTY = 123,
        //P343_A01_ORE_STORAGE = 124,
        //P342_A01_LOADING_BAY = 125,
        //P341_B01_OPEN_DOCK_VARIATION1 = 126,
        //P341_B02_OPEN_DOCK_VARIATION2 = 127,
        //P341_A01_OPEN_DOCK_VARIATION1 = 128,
        //P341_A02_OPEN_DOCK_VARIATION2 = 129,
        //P333_A01_HYDROPONIC_BUILDING = 130,
        //P332_A01_OXYGEN_STORAGE = 131,
        //P331_A01_OXYGEN_GENERATOR = 132,
        //P324B01_FUEL_STORAGE_B = 133,
        //P324A01_FUEL_STORAGE_A = 134,
        //P323A01_FUEL_GENERATOR = 135,
        //P322A01_BATTERY = 136,
        //P321C01_INERTIA_GENERATOR = 137,
        //P321B01_NUCLEAR_REACTOR = 138,
        //P321A01_SOLAR_PANEL = 139,
        //P312A01_SHORT_TERM_THRUSTER_LATITUDE = 140,
        //P312A02_SHORT_TERM_THRUSTER_LATERAL = 141,
        //P311A01_LONG_TERM_THRUSTER = 142,
        //P231A01_ARMOR = 143,
        //P231A02_ARMOR = 144,
        //P231A03_ARMOR = 145,
        //P231A04_ARMOR = 146,
        //P231A05_ARMOR = 147,
        //P231A06_ARMOR = 148,
        //P231A07_ARMOR = 149,
        //P231A08_ARMOR = 150,
        //P231A09_ARMOR = 151,
        //P231A10_ARMOR = 152,
        //P231A11_ARMOR = 153,
        //P231A12_ARMOR = 154,
        //P231A13_ARMOR = 155,
        //P231A14_ARMOR = 156,
        //P231A15_ARMOR = 157,
        //P231A16_ARMOR = 158,
        //P231A17_ARMOR = 159,
        //P231A18_ARMOR = 160,
        //P221E01_CHAMBER_V1 = 161,
        //P221D01_CHAMBER_V1 = 162,
        //P221C01_CHAMBER_V1 = 163,
        //P221B01_CHAMBER_V1 = 164,
        //P221A01_CHAMBER_V1 = 165,
        //P211G01_PANEL_120MX60M = 166,
        //P211G02_PANEL_60MX60M = 167,
        //P211G03_PANEL_60MX30M = 168,
        //P211F01_PANEL_120MX60M = 169,
        //P211F02_PANEL_60MX60M = 170,
        //P211F03_PANEL_60MX30M = 171,
        //P211E01_PANEL_120MX60M = 172,
        //P211E02_PANEL_60MX60M = 173,
        //P211E03_PANEL_60MX30M = 174,
        //P211D01_PANEL_120MX60M = 175,
        //P211D02_PANEL_60MX60M = 176,
        //P211D03_PANEL_60MX30M = 177,
        //P211C01_PANEL_120MX60M = 178,
        //P211C02_PANEL_60MX60M = 179,
        //P211C03_PANEL_60MX30M = 180,
        //P211B01_PANEL_120MX60M = 181,
        //P211B02_PANEL_60MX60M = 182,
        //P211B03_PANEL_60MX30M = 183,
        //P211A01_PANEL_120MX60M = 184,
        //P211A02_PANEL_60MX60M = 185,
        //P211A03_PANEL_60MX30M = 186,
        //P142B01_CAGE_EMPTY = 187,
        //P142B02_CAGE_HALFCUT = 188,
        //P142B03_CAGE_WITH_CORNERS = 189,
        //P142B11_CAGE_PILLAR = 190,
        //P142B12_CAGE_EDGE = 191,
        //P142A01_CAGE_EMPTY = 192,
        //P142A02_CAGE_HALFCUT = 193,
        //P142A03_CAGE_WITH_CORNERS = 194,
        //P142A11_CAGE_PILLAR = 195,
        //P142A12_CAGE_EDGE = 196,
        //P141B01_THICK_FRAME_STRAIGHT_10M = 197,
        //P141B02_THICK_FRAME_STRAIGHT_60M = 198,
        //P141B11_THICK_FRAME_EDGE = 199,
        //P141B12_THICK_FRAME_CORNER = 200,
        //P141B31_THICK_FRAME_JOINT = 201,
        //P141A01_THICK_FRAME_STRAIGHT_10M = 202,
        //P141A02_THICK_FRAME_STRAIGHT_60M = 203,
        //P141A11_THICK_FRAME_EDGE = 204,
        //P141A12_THICK_FRAME_CORNER = 205,
        //P141A31_THICK_FRAME_JOINT = 206,
        //P120J01_J_STRAIGHT_30M = 207,
        //P130J02_J_STRAIGHT_10M = 208,
        //P120I01_I_STRAIGHT_30M = 209,
        //P130I02_I_STRAIGHT_10M = 210,
        //P120H01_H_STRAIGHT_30M = 211,
        //P130H02_H_STRAIGHT_10M = 212,
        //P120G01_G_STRAIGHT_30M = 213,
        //P130G02_G_STRAIGHT_10M = 214,
        //P120F01_F_STRAIGHT_30M = 215,
        //P130F02_F_STRAIGHT_10M = 216,
        //P120E01_E_STRAIGHT_30M = 217,
        //P130E02_E_STRAIGHT_10M = 218,
        //P120D01_D_STRAIGHT_30M = 219,
        //P130D02_D_STRAIGHT_10M = 220,
        //P120C01_C_STRAIGHT_30M = 221,
        //P130C02_C_STRAIGHT_10M = 222,
        //P120B01_B_STRAIGHT_30M = 223,
        //P130B02_B_STRAIGHT_10M = 224,
        //P120A01_A_STRAIGHT_30M = 225,
        //P130A02_A_STRAIGHT_10M = 226,
        //P120D01_D_STRAIGHT_10M = 227,
        //P120D02_D_STRAIGHT_40M = 228,
        //P120C01_C_STRAIGHT_10M = 229,
        //P120C02_C_STRAIGHT_40M = 230,
        //P120B01_B_STRAIGHT_10M = 231,
        //P120B02_B_STRAIGHT_40M = 232,
        //P120A01_STRONG_LATTICE_STRAIGHT_10M = 233,
        //P120A02_STRONG_LATTICE_STRAIGHT_60M = 234,
        //P120A03_STRONG_LATTICE_STRAIGHT_120M = 235,
        //P120A21_STRONG_LATTICE_JUNCTION_T_STRONG = 236,
        //P120A22_STRONG_LATTICE_JUNCTION_T_WEAK = 237,
        //P120A23_STRONG_LATTICE_JUNCTION_T_ROTATED = 238,
        //P120A51_STRONG_TO_WEAK_LATTICE_2TO1 = 239,
        //P120A52_STRONG_TO_WEAK_LATTICE_1TO2 = 240,
        //P120A61_WEAK_LATTICE_JUNCTION_T_ROTATED = 241,
        //P110B01_LATTICE_BEAM_STRAIGHT_10M = 242,
        //P110B02_LATTICE_BEAM_STRAIGHT_30M = 243,
        //P110B03_LATTICE_BEAM_STRAIGHT_60M = 244,
        //P110B04_LATTICE_BEAM_STRAIGHT_60M_WITH_PANELS = 245,
        //P110B21_LATTICE_BEAM_JUNCTION_T_STRONG = 246,
        //P110B22_LATTICE_BEAM_JUNCTION_T_WEAK = 247,
        //P110B31_LATTICE_BEAM_JOINT_HORIZONTAL = 248,
        //P110B32_LATTICE_BEAM_JOINT_VERTICAL = 249,
        //P110A01_SOLID_BEAM_STRAIGHT_10M = 250,
        //P110A02_SOLID_BEAM_STRAIGHT_20M = 251,
        //P110A03_SOLID_BEAM_STRAIGHT_40M_WITH_HOLE = 252,
        //P110A04_SOLID_BEAM_STRAIGHT_40M_LATTICE = 253,
        //P110A05_SOLID_BEAM_STRAIGHT_80M = 254,
        //P110A11_SOLID_BEAM_JUNCTION_X_STRONG = 255,
        //P110A12_SOLID_BEAM_JUNCTION_X_WEAK = 256,
        //P110A13_SOLID_BEAM_JUNCTION_X_ROTATED = 257,
        //P110A21_SOLID_BEAM_JUNCTION_T_STRONG = 258,
        //P110A22_SOLID_BEAM_JUNCTION_T_WEAK = 259,
        //P110A23_SOLID_BEAM_JUNCTION_T_ROTATED = 260,
        //P110A31_SOLID_BEAM_JOINT_HORIZONTAL = 261,
        //P110A32_SOLID_BEAM_JOINT_VERTICAL = 262,
        //P110A33_SOLID_BEAM_JOINT_LONGITUDINAL = 263,
        //P110A41_SOLID_BEAM_SUPERJOINT = 264,
        //DEFAULT_LIGHT_0,//rename i = 265,
        //P521_A01_LIGHT1 = 266,
        //P521_A02_LIGHT2 = 267,
        //P521_A03_LIGHT3 = 268,
        //P521_A04_LIGHT4 = 269,
        //DEFAULT_PARTICLE_PREFAB_0 = 270,
        //P551_A01_PARTICLES = 271,
        //P551_B01_PARTICLES = 272,
        //P551_C01_PARTICLES = 273,
        //P551_D01_PARTICLES = 274,
        //DEFAULT_SOUND_PREFAB_0 = 275,
        //P561_A01_SOUND = 276,
        //P561_B01_SOUND = 277,
        //P561_C01_SOUND = 278,
        //P561_D01_SOUND = 279,
        //P352_A01_LARGESHIP_AUTOCANNON = 280,
        //P352_A01_LARGESHIP_MACHINEGUN = 281,
        //P352_A01_LARGESHIP_CIWS = 282,
        //P352_A01_LARGESHIP_MISSILE_BASIC4 = 283,
        //P352_A01_LARGESHIP_MISSILE_BASIC6 = 284,
        //P352_A01_LARGESHIP_MISSILE_BASIC9 = 285,
        //P352_A02_LARGESHIP_MISSILE_GUIDED4 = 286,
        //P352_A02_LARGESHIP_MISSILE_GUIDED6 = 287,
        //P352_A02_LARGESHIP_MISSILE_GUIDED9 = 288,
        //P511_A01_BILLBOARD = 289,
        //P511_A02_BILLBOARD = 290,
        //P511_A03_BILLBOARD = 291,
        //P511_A04_BILLBOARD = 292,
        //P511_A05_BILLBOARD = 293,
        //P511_A06_BILLBOARD = 294,
        //P511_A07_BILLBOARD = 295,
        //P511_A08_BILLBOARD = 296,
        //P511_A09_BILLBOARD = 297,
        //P511_A10_BILLBOARD = 298,
        //P511_A11_BILLBOARD = 299,
        //P511_A12_BILLBOARD = 300,
        //P511_A13_BILLBOARD = 301,
        //P511_A14_BILLBOARD = 302,
        //P511_A15_BILLBOARD = 303,
        //P511_A16_BILLBOARD = 304,
        //P531_A01_SIGN1 = 305,
        //P531_A02_SIGN2 = 306,
        //P531_A03_SIGN3 = 307,
        //P531_A04_SIGN4 = 308,
        //P531_A05_SIGN5 = 309,
        //P531_A06_SIGN6 = 310,
        //P531_A07_SIGN7 = 311,
        //P531_A08_SIGN8 = 312,
        //P531_A09_SIGN9 = 313,
        //P531_A10_SIGN10 = 314,
        //P531_A11_SIGN11 = 315,
        //P531_A12_SIGN12 = 316,
        //P221_A02_CHAMBER_V2 = 317,
        //P221_B02_CHAMBER_V2 = 318,
        //P221_C02_CHAMBER_V2 = 319,
        //P221_D02_CHAMBER_V2 = 320,
        //P221_E02_CHAMBER_V2 = 321,
        //P130_A01_STRAIGHT_10M = 322,
        //P130_A02_STRAIGHT_30M = 323,
        //P130_B01_STRAIGHT_10M = 324,
        //P130_B02_STRAIGHT_30M = 325,
        //P130_C01_STRAIGHT_10M = 326,
        //P130_C02_STRAIGHT_30M = 327,
        //P130_D01_STRAIGHT_10M = 328,
        //P130_D02_STRAIGHT_30M = 329,
        //P130_E01_STRAIGHT_10M = 330,
        //P130_E02_STRAIGHT_30M = 331,
        //P321_B01_SOLAR_PANEL = 332,
        //P321_C01_SOLAR_PANEL = 333,
        //P413_D02_JUNCTION_T_VERTICAL = 334,
        //P413_D04_JUNCTION_X_VERTICAL = 335,
        //P412_F11_TURN_90_UP_230M = 336,
        //P412_F12_TURN_90_LEFT_230M = 337,
        //P412_F13_TURN_90_RIGHT_230M = 338,
        //P412_F14_TURN_90_DOWN_230M = 339,
        //P411_F04_STRAIGHT_4 = 340,
        //P411_F05_STRAIGHT_5 = 341,
        //P411_G05_STRAIGHT_5 = 342,
        //P414_F01_ENTRANCE_60M = 343,
        //P414_G01_ENTRANCE_60M = 344,
        //P571_A01_TRAFFIC_SIGN = 345,
        //P571_B01_TRAFFIC_SIGN = 346,
        //P571_BOX01_TRAFFIC_SIGN = 347,
        //P571_BOX02_TRAFFIC_SIGN = 348,
        //P571_C01_TRAFFIC_SIGN = 349,
        //P571_D01_TRAFFIC_SIGN = 350,
        //P571_E01_TRAFFIC_SIGN = 351,
        //P571_F01_TRAFFIC_SIGN = 352,
        //P571_G01_TRAFFIC_SIGN = 353,
        //P571_H01_TRAFFIC_SIGN = 354,
        //P571_I01_TRAFFIC_SIGN = 355,
        //P571_J01_TRAFFIC_SIGN = 356,
        //P571_K01_TRAFFIC_SIGN = 357,
        //P571_L01_TRAFFIC_SIGN = 358,
        //SMALL_SHIP_WEAPON_CANNON = 359,
        //SMALL_SHIP_WEAPON_AUTOCANNON = 360,
        //SMALL_SHIP_WEAPON_SHOTGUN = 361,
        //SMALL_SHIP_WEAPON_MACHINE_GUN = 362,
        //SMALL_SHIP_WEAPON_SNIPER = 363,
        //SMALL_SHIP_WEAPON_AUTOMATIC_RIFLE_WITH_SILENCER = 364,
        //SMALL_SHIP_WEAPON_UNIVERSAL_LAUNCHER_BACK = 365,
        //SMALL_SHIP_WEAPON_UNIVERSAL_LAUNCHER_FRONT = 366,
        //SMALL_SHIP_WEAPON_HARVESTING_DEVICE = 367,
        //SMALL_SHIP_WEAPON_DRILLING_DEVICE_CRUSHER = 368,
        //SMALL_SHIP_WEAPON_DRILLING_DEVICE_THERMAL = 369,
        //SMALL_SHIP_WEAPON_DRILLING_DEVICE_SAW = 370,
        //SMALL_SHIP_WEAPON_DRILLING_DEVICE_NUCLEAR = 371,
        //SMALL_SHIP_WEAPON_DRILLING_DEVICE_LASER = 372,
        //SMALL_SHIP_WEAPON_DRILLING_DEVICE_PRESSURE = 373,
        //SMALL_SHIP_WEAPON_MISSILE_LAUNCHER = 374,
        //P385_A01_TEMPLE_900M = 375,
        //P384_A01_HOSPITAL = 376,
        //P383_A01_CHURCH = 377,
        //P334_A01_FOOD_GROW = 378,
        //P345_A01_BIO_EXP = 379,
        //P345_A01_BIO_MACH_EXP = 380,
        //P345_A01_RECYCLE = 381,
        //P541_ESCAPE_POD = 382,
        //P541_ESCAPE_POD_BASE = 383,
        //P541_VENTILATOR_BODY = 384,
        //P541_VENTILATOR_PROPELLER = 385,
        //P349_A_TOWER = 386,
        //P349_B_TOWER = 387,
        //P349_C_TOWER = 388,
        //P361_A02_HANGAR_PANEL = 389,

        // new real blueprints
        BasicConstructionKit = 390,
        AdvancedConstructionKit = 391,
        SuperiorConstructionKit = 392,
        UtilitiesKit = 393,
        FortificationKit = 394,
        HonorableKit = 395,
        WeaponKit = 369,
    }
    
    public class MyMwcObjectBuilder_Blueprint : MyMwcObjectBuilder_SubObjectBase
    {                
        public MyMwcObjectBuilder_Blueprint_TypesEnum BlueprintType { get; set; }

        internal MyMwcObjectBuilder_Blueprint()
            : base()
        {
        }

        public MyMwcObjectBuilder_Blueprint(MyMwcObjectBuilder_Blueprint_TypesEnum blueprintType)
        {
            BlueprintType = blueprintType;
        }

        public override MyMwcObjectBuilderTypeEnum GetObjectBuilderType()
        {
            return MyMwcObjectBuilderTypeEnum.Blueprint;
        }

        public override int? GetObjectBuilderId()
        {
            return (int)BlueprintType;
        }

        internal override void SetObjectBuilderIdInternal(int? objectBuilderId)
        {
            BlueprintType = (MyMwcObjectBuilder_Blueprint_TypesEnum)Convert.ToUInt16(objectBuilderId);
        }

        //  Write this object into message-out
        internal override void Write(BinaryWriter binaryWriter)
        {
            base.Write(binaryWriter);

            //  Blueprint type
            MyMwcLog.IfNetVerbose_AddToLog("BlueprintType: " + BlueprintType);
            MyMwcMessageOut.WriteObjectBuildeBlueprintTypesEnum(BlueprintType, binaryWriter);
        }

        //  Read this object from message-in
        internal override bool Read(BinaryReader binaryReader, EndPoint senderEndPoint, int gameVersion)
        {
            if (base.Read(binaryReader, senderEndPoint, gameVersion) == false) return NetworkError();

            //  Blueprint type
            MyMwcObjectBuilder_Blueprint_TypesEnum? blueprintType = MyMwcMessageIn.ReadObjectBuilderBlueprintTypesEnumEx(binaryReader, senderEndPoint);
            if (blueprintType == null) return NetworkError();
            BlueprintType = blueprintType.Value;
            MyMwcLog.IfNetVerbose_AddToLog("BlueprintType: " + BlueprintType);

            return true;
        }

        public override string ToString()
        {
            return base.GetType().Name + "(" + BlueprintType.ToString() + ")";
        }
    }
}
