﻿using MinerWars.CommonLIB.AppCode.Utils;
using System.IO;
using System.Net;
using System.Data.SqlClient;
using System;
using SysUtils.Utils;
using MinerWars.CommonLIB.AppCode.Networking;
using MinerWarsMath;

namespace MinerWars.CommonLIB.AppCode.ObjectBuilders.SubObjects
{
    //  IMPORTANT: Never change numeric values and never delete any enum item. These numbers are referenced e.g. from database.
    public enum MyMwcObjectBuilder_Prefab_TypesEnum : ushort
    {
        P430_A01_PASSAGE_10M=0,
        P430_A02_PASSAGE_40M=1,
        P424_A01_PIPE_BASE=2,
        P423_A01_PIPE_JUNCTION=3,
        P422_A01_PIPE_TURN_90=4,
        P421_A01_PIPE_STRAIGHT_80M=5,
        P421_A02_PIPE_STRAIGHT_40M=6,
        P421_A03_PIPE_STRAIGHT_10M=7,
        P413_G01_JUNCTION_6AXES=8,
        P414_G02_ENTRANCE_60M=9,
        P410_G01_TURN_90_RIGHT_0M=10,
        P411_G01_STRAIGHT_1=11,
        P411_G02_STRAIGHT_2=12,
        P411_G03_STRAIGHT_3=13,
        P411_G04_STRAIGHT_4=14,
        //P414_F02_ENTRANCE_60M=15,
        P412_F21_TURN_S_UP=16,
        P412_F22_TURN_S_LEFT=17,
        P412_F23_TURN_S_RIGHT=18,
        P412_F24_TURN_S_DOWN=19,
        P412_F01_TURN_90_UP_230M=20,
        P412_F02_TURN_90_LEFT_230M=21,
        P412_F03_TURN_90_RIGHT_230M=22,
        P412_F04_TURN_90_DOWN_230M=23,
        P411_F01_STRAIGHT_1=24,
        P411_F02_STRAIGHT_2=25,
        P411_F03_STRAIGHT_3=26,
        P414_E01_ENTRANCE_60M=27,
        P411_E01_STRAIGHT_1=28,
        P411_E02_STRAIGHT_2=29,
        P411_E03_STRAIGHT_3=30,
        P411_E04_STRAIGHT_4=31,
        P411_E05_STRAIGHT_5=32,
        P415_D01_DOORCASE=33,
        P415_D02_DOOR1=34,
        P415_D03_DOOR2_A=35,
        P415_D03_DOOR2_B=36,
        P413_D01_JUNCTION_T_HORIZONTAL=37,
        P413_D03_JUNCTION_X_HORIZONTAL=38,
        P414_D01_ENTRANCE_60M=39,
        P411_D01_STRAIGHT_10M=40,
        P411_D02_STRAIGHT_40M_WITH_HOLE=41,
        P411_D03_STRAIGHT_60M=42,
        P411_D04_STRAIGHT_120M=43,
        P411_D05_STRAIGHT_180M=44,
        //P415_C01_DOOR1=45,
        //P415_C01_DOOR2=46,
        //P415_C01_DOOR3=47,
        //P415_C01_DOOR4=48,
        P413_C01_JUNCTION_T_HORIZONTAL=49,
        P413_C01_JUNCTION_X_HORIZONTAL=50,
        P414_C01_ENTRANCE_60M=51,
        P411_C01_STRAIGHT_10M=52,
        P411_C02_STRAIGHT_40M_WITH_HOLE=53,
        P411_C03_STRAIGHT_60M=54,
        P411_C04_STRAIGHT_120M=55,
        P411_C05_STRAIGHT_180M=56,
        P415_B01_DOORCASE=57,
        //P415_B02_DOOR=58,
        P413_B01_JUNCTION_T_HORIZONTAL=59,
        P413_B02_JUNCTION_T_VERTICAL=60,
        P414_B02_ENTRANCE_60M=61,
        P412_B21_TURN_S_UP=62,
        P412_B22_TURN_S_LEFT=63,
        P412_B23_TURN_S_RIGHT=64,
        P412_B24_TURN_S_DOWN=65,
        P412_B11_TURN_90_UP_160M=66,
        P412_B12_TURN_90_LEFT_160M=67,
        P412_B13_TURN_90_RIGHT_160M=68,
        P412_B14_TURN_90_DOWN_160M=69,
        P412_B01_TURN_90_UP_80M=70,
        P412_B02_TURN_90_LEFT_80M=71,
        P412_B03_TURN_90_RIGHT_80M=72,
        P412_B04_TURN_90_DOWN_80M=73,
        P411_B01_STRAIGHT_10M=74,
        p411_B02_STRAIGHT_30M_YELLOW=75,
        p411_B03_STRAIGHT_320M=76,
        p411_B04_STRAIGHT_80M_WITH_SIDE_GRATES=77,
        p411_B05_STRAIGHT_80M_WITH_SIDE_OPEN=78,
        //P415_A01_DOORCASE=79,
        //P415_A02_DOOR_LEFT=80,
        //P415_A02_DOOR_RIGHT=81,
        P413_A01_JUNCTION_T_HORIZONTAL=82,
        P413_A02_JUNCTION_T_VERTICAL=83,
        //P414_A01_ENTRANCE_30M=84,
        P414_A02_ENTRANCE_60M=85,
        P412_A21_TURN_S_UP=86,
        P412_A22_TURN_S_LEFT=87,
        P412_A23_TURN_S_RIGHT=88,
        P412_A24_TURN_S_DOWN=89,
        P412_A11_TURN_90_UP_160M=90,
        P412_A12_TURN_90_LEFT_160M=91,
        P412_A13_TURN_90_RIGHT_160M=92,
        P412_A14_TURN_90_DOWN_160M=93,
        P412_A01_TURN_90_UP_80M=94,
        P412_A02_TURN_90_LEFT_80M=95,
        P412_A03_TURN_90_RIGHT_80M=96,
        P412_A04_TURN_90_DOWN_80M=97,
        P411_A01_STRAIGHT_10M=98,
        P411_A02_STRAIGHT_60M_WITH_HOLE=99,
        P411_A03_STRAIGHT_120M=100,
        P411_A04_STRAIGHT_80M=101,
        P411_A05_STRAIGHT_80M_WITH_EXTENSION=102,
        P382_E01_BRIDGE5=103,
        P382_D01_BRIDGE4=104,
        P382_C01_BRIDGE3=105,
        P382_B01_BRIDGE2=106,
        P382_A01_BRIDGE1=107,
        P381_C01_BUILDING3=108,
        P381_B01_BUILDING2=109,
        P381_A01_BUILDING1=110,
        //P361_A01_SMALL_HANGAR=111,
        P362_A01_SHORT_DISTANCE_ANTENNA=112,
        P361_A01_LONG_DISTANCE_ANTENNA=113,
        P351_A01_WEAPON_MOUNT=114,
        P345_A01_REFINERY=115,
        P344_A01_CONTAINER_ARM_FILLED=116,
        P344_A02_CONTAINER_ARM_EMPTY=117,
        P343_A01_ORE_STORAGE=118,
        P342_A01_LOADING_BAY=119,
        P341_B01_OPEN_DOCK_VARIATION1=120,
        P341_B02_OPEN_DOCK_VARIATION2=121,
        //P341_A01_OPEN_DOCK_VARIATION1=122,
        P341_A02_OPEN_DOCK_VARIATION2=123,
        P333_A01_HYDROPONIC_BUILDING=124,
        P332_A01_OXYGEN_STORAGE=125,
        P331_A01_OXYGEN_GENERATOR=126,
        P324B01_FUEL_STORAGE_B=127,
        P324A01_FUEL_STORAGE_A=128,
        P323A01_FUEL_GENERATOR=129,
        P322A01_BATTERY=130,
        //P321C01_INERTIA_GENERATOR=131,
        P321B01_NUCLEAR_REACTOR=132,
        //P321A01_SOLAR_PANEL=133,
        P312A01_SHORT_TERM_THRUSTER_LATITUDE=134,
        P312A02_SHORT_TERM_THRUSTER_LATERAL=135,
        P311A01_LONG_TERM_THRUSTER=136,
        P231A01_ARMOR=137,
        P231A02_ARMOR=138,
        P231A03_ARMOR=139,
        P231A04_ARMOR=140,
        P231A05_ARMOR=141,
        P231A06_ARMOR=142,
        P231A07_ARMOR=143,
        P231A08_ARMOR=144,
        P231A09_ARMOR=145,
        P231A10_ARMOR=146,
        P231A11_ARMOR=147,
        P231A12_ARMOR=148,
        P231A13_ARMOR=149,
        P231A14_ARMOR=150,
        P231A15_ARMOR=151,
        P231A16_ARMOR=152,
        P231A17_ARMOR=153,
        P231A18_ARMOR=154,
        P221E01_CHAMBER_V1=155,
        P221D01_CHAMBER_V1=156,
        P221C01_CHAMBER_V1=157,
        P221B01_CHAMBER_V1=158,
        P221A01_CHAMBER_V1=159,
        P211G01_PANEL_120MX60M=160,
        P211G02_PANEL_60MX60M=161,
        P211G03_PANEL_60MX30M=162,
        P211F01_PANEL_120MX60M=163,
        P211F02_PANEL_60MX60M=164,
        P211F03_PANEL_60MX30M=165,
        P211E01_PANEL_120MX60M=166,
        P211E02_PANEL_60MX60M=167,
        P211E03_PANEL_60MX30M=168,
        P211D01_PANEL_120MX60M=169,
        P211D02_PANEL_60MX60M=170,
        P211D03_PANEL_60MX30M=171,
        P211C01_PANEL_120MX60M=172,
        P211C02_PANEL_60MX60M=173,
        P211C03_PANEL_60MX30M=174,
        P211B01_PANEL_120MX60M=175,
        P211B02_PANEL_60MX60M=176,
        P211B03_PANEL_60MX30M=177,
        P211A01_PANEL_120MX60M=178,
        P211A02_PANEL_60MX60M=179,
        P211A03_PANEL_60MX30M=180,
        P142B01_CAGE_EMPTY=181,
        P142B02_CAGE_HALFCUT=182,
        P142B03_CAGE_WITH_CORNERS=183,
        P142B11_CAGE_PILLAR=184,
        P142B12_CAGE_EDGE=185,
        P142A01_CAGE_EMPTY=186,
        P142A02_CAGE_HALFCUT=187,
        P142A03_CAGE_WITH_CORNERS=188,
        P142A11_CAGE_PILLAR=189,
        P142A12_CAGE_EDGE=190,
        P141B01_THICK_FRAME_STRAIGHT_10M=191,
        P141B02_THICK_FRAME_STRAIGHT_60M=192,
        P141B11_THICK_FRAME_EDGE=193,
        P141B12_THICK_FRAME_CORNER=194,
        P141B31_THICK_FRAME_JOINT=195,
        P141A01_THICK_FRAME_STRAIGHT_10M=196,
        P141A02_THICK_FRAME_STRAIGHT_60M=197,
        P141A11_THICK_FRAME_EDGE=198,
        P141A12_THICK_FRAME_CORNER=199,
        P141A31_THICK_FRAME_JOINT=200,
        P120J01_J_STRAIGHT_30M=201,
        P130J02_J_STRAIGHT_10M=202,
        P120I01_I_STRAIGHT_30M=203,
        P130I02_I_STRAIGHT_10M=204,
        P120H01_H_STRAIGHT_30M=205,
        P130H02_H_STRAIGHT_10M=206,
        //P120G01_G_STRAIGHT_30M=207,
        //P130G02_G_STRAIGHT_10M=208,
        //P120F01_F_STRAIGHT_30M=209,
        //P130F02_F_STRAIGHT_10M=210,
        //P120E01_E_STRAIGHT_30M=211,
        //P130E02_E_STRAIGHT_10M=212,
        //P120D01_D_STRAIGHT_30M=213,
        //P130D02_D_STRAIGHT_10M=214,
        //P120C01_C_STRAIGHT_30M=215,
        //P130C02_C_STRAIGHT_10M=216,
        //P120B01_B_STRAIGHT_30M=217,
        //P130B02_B_STRAIGHT_10M=218,
        //P120A01_A_STRAIGHT_30M=219,
        //P130A02_A_STRAIGHT_10M=220,
        P120D01_D_STRAIGHT_10M=221,
        P120D02_D_STRAIGHT_40M=222,
        P120C01_C_STRAIGHT_10M=223,
        P120C02_C_STRAIGHT_40M=224,
        P120B01_B_STRAIGHT_10M=225,
        P120B02_B_STRAIGHT_40M=226,
        P120A01_STRONG_LATTICE_STRAIGHT_10M=227,
        P120A02_STRONG_LATTICE_STRAIGHT_60M=228,
        P120A03_STRONG_LATTICE_STRAIGHT_120M=229,
        P120A21_STRONG_LATTICE_JUNCTION_T_STRONG=230,
        P120A22_STRONG_LATTICE_JUNCTION_T_WEAK=231,
        P120A23_STRONG_LATTICE_JUNCTION_T_ROTATED=232,
        P120A51_STRONG_TO_WEAK_LATTICE_2TO1=233,
        P120A52_STRONG_TO_WEAK_LATTICE_1TO2=234,
        P120A61_WEAK_LATTICE_JUNCTION_T_ROTATED=235,
        P110B01_LATTICE_BEAM_STRAIGHT_10M=236,
        P110B02_LATTICE_BEAM_STRAIGHT_30M=237,
        P110B03_LATTICE_BEAM_STRAIGHT_60M=238,
        P110B04_LATTICE_BEAM_STRAIGHT_60M_WITH_PANELS=239,
        P110B21_LATTICE_BEAM_JUNCTION_T_STRONG=240,
        P110B22_LATTICE_BEAM_JUNCTION_T_WEAK=241,
        P110B31_LATTICE_BEAM_JOINT_HORIZONTAL=242,
        P110B32_LATTICE_BEAM_JOINT_VERTICAL=243,
        P110A01_SOLID_BEAM_STRAIGHT_10M=244,
        P110A02_SOLID_BEAM_STRAIGHT_20M=245,
        P110A03_SOLID_BEAM_STRAIGHT_40M_WITH_HOLE=246,
        P110A04_SOLID_BEAM_STRAIGHT_40M_LATTICE=247,
        P110A05_SOLID_BEAM_STRAIGHT_80M=248,
        P110A11_SOLID_BEAM_JUNCTION_X_STRONG=249,
        P110A12_SOLID_BEAM_JUNCTION_X_WEAK=250,
        P110A13_SOLID_BEAM_JUNCTION_X_ROTATED=251,
        P110A21_SOLID_BEAM_JUNCTION_T_STRONG=252,
        P110A22_SOLID_BEAM_JUNCTION_T_WEAK=253,
        P110A23_SOLID_BEAM_JUNCTION_T_ROTATED=254,
        P110A31_SOLID_BEAM_JOINT_HORIZONTAL=255,
        P110A32_SOLID_BEAM_JOINT_VERTICAL=256,
        P110A33_SOLID_BEAM_JOINT_LONGITUDINAL=257,
        P110A41_SOLID_BEAM_SUPERJOINT=258,
        ////@ Lights
        //DEFAULT_LIGHT_0=259,//rename it
        //P521_A01_LIGHT1=260,
        //P521_A02_LIGHT2=261,
        //P521_A03_LIGHT3=262,
        //P521_A04_LIGHT4=263,
        ////@ Particles
        //DEFAULT_PARTICLE_PREFAB_0=264,
        //P551_A01_PARTICLES=265,
        //P551_B01_PARTICLES=266,
        //P551_C01_PARTICLES=267,
        //P551_D01_PARTICLES=268,
        ////@ Sounds
        //DEFAULT_SOUND_PREFAB_0=269,
        //P561_A01_SOUND=270,
        //P561_B01_SOUND=271,
        //P561_C01_SOUND=272,
        //P561_D01_SOUND=273,

        //P351_A01_WEAPON_MOUNT
        //P352_A01_LARGESHIP_AUTOCANNON=274,
        //P352_A01_LARGESHIP_MACHINEGUN=275,
        //P352_A01_LARGESHIP_CIWS=276,
        //P352_A01_LARGESHIP_MISSILE_BASIC4=277,
        //P352_A01_LARGESHIP_MISSILE_BASIC6=278,
        //P352_A01_LARGESHIP_MISSILE_BASIC9=279,
        //P352_A02_LARGESHIP_MISSILE_GUIDED4=280,
        //P352_A02_LARGESHIP_MISSILE_GUIDED6=281,
        //P352_A02_LARGESHIP_MISSILE_GUIDED9=282,

        //@ Details:
        P511_A01_BILLBOARD=283,
        P511_A02_BILLBOARD=284,
        P511_A03_BILLBOARD=285,
        P511_A04_BILLBOARD=286,
        P511_A05_BILLBOARD=287,
        P511_A06_BILLBOARD=288,
        P511_A07_BILLBOARD=289,
        P511_A08_BILLBOARD=290,
        P511_A09_BILLBOARD=291,
        P511_A10_BILLBOARD=292,
        P511_A11_BILLBOARD=293,
        P511_A12_BILLBOARD=294,
        //P511_A13_BILLBOARD=295,
        P511_A14_BILLBOARD=296,
        P511_A15_BILLBOARD=297,
        P511_A16_BILLBOARD=298,

        //@ Signs:
        P531_A01_SIGN1=299,
        P531_A02_SIGN2=300,
        P531_A03_SIGN3=301,
        P531_A04_SIGN4=302,
        P531_A05_SIGN5=303,
        P531_A06_SIGN6=304,
        P531_A07_SIGN7=305,
        P531_A08_SIGN8=306,
        P531_A09_SIGN9=307,
        P531_A10_SIGN10=308,
        P531_A11_SIGN11=309,
        P531_A12_SIGN12=310,

        //@ Chambers:
        P221_A02_CHAMBER_V2=311,
        P221_B02_CHAMBER_V2=312,
        P221_C02_CHAMBER_V2=313,
        P221_D02_CHAMBER_V2=314,
        P221_E02_CHAMBER_V2=315,

        //@ Straight prefab:
        P130_A01_STRAIGHT_10M=316,
        P130_A02_STRAIGHT_30M=317,
        P130_B01_STRAIGHT_10M=318,
        P130_B02_STRAIGHT_30M=319,
        P130_C01_STRAIGHT_10M=320,
        P130_C02_STRAIGHT_30M=321,
        P130_D01_STRAIGHT_10M=322,
        P130_D02_STRAIGHT_30M=323,
        P130_E01_STRAIGHT_10M=324,
        P130_E02_STRAIGHT_30M=325,

        P321_B01_SOLAR_PANEL=326,
        P321_C01_SOLAR_PANEL=327,

        P413_D02_JUNCTION_T_VERTICAL=328,
        P413_D04_JUNCTION_X_VERTICAL=329,

        P412_F11_TURN_90_UP_230M=330,
        P412_F12_TURN_90_LEFT_230M=331,
        P412_F13_TURN_90_RIGHT_230M=332,
        P412_F14_TURN_90_DOWN_230M=333,

        P411_F04_STRAIGHT_4=334,
        P411_F05_STRAIGHT_5=335,
        P411_G05_STRAIGHT_5=336,
        P414_F01_ENTRANCE_60M=337,
        P414_G01_ENTRANCE_60M=338,

        P571_A01_TRAFFIC_SIGN=339,
        P571_B01_TRAFFIC_SIGN=340,
        P571_BOX01_TRAFFIC_SIGN=341,
        P571_BOX02_TRAFFIC_SIGN=342,
        P571_C01_TRAFFIC_SIGN=343,
        P571_D01_TRAFFIC_SIGN=344,
        P571_E01_TRAFFIC_SIGN=345,
        P571_F01_TRAFFIC_SIGN=346,
        P571_G01_TRAFFIC_SIGN=347,
        P571_H01_TRAFFIC_SIGN=348,
        P571_I01_TRAFFIC_SIGN=349,
        P571_J01_TRAFFIC_SIGN=350,
        P571_K01_TRAFFIC_SIGN=351,
        P571_L01_TRAFFIC_SIGN=352,

        //User
        SimpleObject=353,

        //P415_C02_DOOR1_RIGHT=354,
        //P415_C02_DOOR1_LEFT=355,
        //P415_C03_DOOR2_A=356,
        //P415_C03_DOOR2_B=357,
        //P415_C03_DOOR2_A_LEFT=358,
        //P415_C03_DOOR2_A_RIGHT=359,
        //P415_C03_DOOR2_B_LEFT=360,
        //P415_C03_DOOR2_B_RIGHT=361,
        //P341_A01_OPEN_DOCK_VARIATION1_DOORLEFT=362,
        //P341_A01_OPEN_DOCK_VARIATION1_DOORRIGHT=363,

        p411_B06_STRAIGHT_180M_CONCRETE=364,
        p411_B06_STRAIGHT_200M=365,
        p411_B07_STRAIGHT_180M_BLUE=366,
        p411_B09_STRAIGHT_30M_GRAY=367,
        p411_B11_STRAIGHT_220M=368,
        p411_B12_STRAIGHT_160M_DARK_METAL=369,
        p411_B13_STRAIGHT_100M_TUBE_INSIDE=370,

        P385_A01_TEMPLE_900M=371,
        //P384_A01_HOSPITAL=372,
        P383_A01_CHURCH=373,
        P334_A01_FOOD_GROW=374,
        P345_A01_BIO_EXP=375,
        P345_A01_BIO_MACH_EXP=376,
        P345_A01_RECYCLE=377,

        //// Largeships
        //LARGESHIP_KAI = 378,
        //LARGESHIP_SAYA = 379,
        //LARGESHIP_ARDANT = 380,

        P541_ESCAPE_POD = 381,
        P541_ESCAPE_POD_BASE = 382,
        P541_VENTILATOR_BODY = 383,
        P541_VENTILATOR_PROPELLER = 384,

        P349_A_TOWER = 385,
        P349_B_TOWER = 386,
        P349_C_TOWER = 387,

        //P361_A02_HANGAR_PANEL = 388,

        //anotgher signs..
        P531_B_FACTION = 389,
        P531_B_FACTION_HOLO = 390,
        ARMOR_HULL = 391,

        //new concrete and metal bariers
        P212A01_PANEL_LARGE = 392,
        P212A01_PANEL_MEDIUM = 393,
        P212A01_PANEL_SMALL = 394,
        P212B02_PANEL_MEDIUM = 395,
        P212B02_PANEL_SMALL = 396,
        P212C03_PANEL_MEDIUM = 397,
        P212C03_PANEL_SMALL = 398,
        P212D04_PANEL_MEDIUM = 399,
        P212D04_PANEL_SMALL = 400,
        P212E05_PANEL_MEDIUM = 401,
        P212E05_PANEL_SMALL = 402,

        //new stuff, dock and chamber..
        P221F01_CHAMBER_V1 = 403,
        P341_C01_CLOSED_DOCK_V1 = 404,

        //more concrete bariers (another size variations) 
        P212B02_PANEL_LARGE = 405,
        P212C03_PANEL_LARGE = 406,
        P212D04_PANEL_LARGE = 407,
        P212E05_PANEL_LARGE = 408,
        P212F01_PANEL_LARGE = 409,

        P391_ALIEN_GATE = 410,

        //P381_D01_BIO_EXP = 411,   
        //P381_D02_CHURCH = 412,
        P381_D03_HOSPITAL = 413,
        //P381_D04_RECYCLE = 414,
        P381_D05_FOOD_GROW = 415,
        //P381_D06_TEMPLE_900M = 416,
        //P381_D07_BIO_MACH_EXP = 417,
        P381_C01_BUILDING4 = 418,

        CABLE_CORNER_25M = 419,
        CABLE_S_45M = 420,
        CABLE_STRAIGHT_180 = 421,
        CABLE_STRAIGHT_45 = 422,
        CABLE_STRAIGHT_90 = 423,
        CONNECTION_BOX = 424,

        P221G01_CHAMBER_V1 = 425,
        P221H01_CHAMBER_V1 = 426,
        P221J01_CHAMBER_V1 = 427,
        P221K01_CHAMBER_V1 = 428,

        P211H01_PANEL_535MX130M = 429,

        P531_C_ADMINISTRATIVE_AREA = 430,
        P531_C_ARMORY = 431,
        P531_C_ARROW_L = 432,
        P531_C_ARROW_R = 433,
        P531_C_ARROW_STR = 434,
        P531_C_CARGO_BAY = 435,
        P531_C_COMMAND_CENTER = 436,
        P531_C_COMMERCIAL_AREA = 437,
        P531_C_COMMUNICATIONS = 438,
        P531_C_DEFENSES = 439,
        P531_C_DOCKS = 440,
        P531_C_EMERGENCY_EXIT = 441,
        P531_C_ENGINEERING_AREA = 442,
        P531_C_EXIT = 443,
        P531_C_EXPERIMENTAL_LABS = 444,
        P531_C_FOUNDRY = 445,
        P531_C_HABITATS = 446,
        P531_C_HANGARS = 447,
        P531_C_INDUSTRIAL_AREA = 448,
        P531_C_LANDING_BAY = 449,
        P531_C_MAINTENANCE = 450,
        P531_C_MILITARY_AREA = 451,
        P531_C_MINES = 452,
        P531_C_ORE_PROCESSING = 453,
        P531_C_OUTER_AREA = 454,
        P531_C_PRISON = 455,
        P531_C_PUBLIC_AREA = 456,
        P531_C_REACTOR = 457,
        P531_C_RESEARCH = 458,
        P531_C_RESTRICTED_AREA = 459,
        P531_C_SECURITY = 460,
        P531_C_SIGN = 461,
        P531_C_STORAGE = 462,
        P531_C_TECHNICAL_AREA = 463,
        P531_C_TRADE_PORT = 464,

        P321_D01_BIG_SOLAR_PANEL = 465,
        P541_VENTILATOR = 466,
        P361_B01_LONG_DISTANCE_ANTENNA_BIG = 467,
        FOURTH_REICH_WRECK = 468,
        P344_A03_CONTAINER = 469,
        P231B01_ARMOR = 470,
        P231B01_ARMOR_CORNER = 471,
        P231B01_ARMOR_EDGE = 472,
        P231B01_ARMOR_HOLE = 473,

        P150A03_SHELF_1 = 474,
        P150A02_SHELF_1X2 = 475,
        P150A01_SHELF_1X3 = 476,
        //AsteroidPrefabTest = 477,

        P611_ASTEROID_PART_A = 478,
        P611_ASTEROID_PART_B = 479,
        P363_A01_BIG_ANTENNA_300M = 480,
        P130D02_D_STRAIGHT_300M = 481,
        P130J01_J_STRAIGHT_300M = 482,
        P120C02_C_STRAIGHT_400M = 483,
        P110B03_LATTICE_BEAM_STRAIGHT_420M = 484,
        P110B04_LATTICE_BEAM_STRAIGHT_420M_WITH_PANELS = 485,
        
        P363_A01_BIG_ANTENNA_1500M = 486,
        P4221_A01_COOLING_DEVICE_WALL_340X400 = 487,
        P4222_A01_PIPES_CONNECTOR = 488,
        P4223_A01_OPEN_PIPE = 489,
        P311B01_LONG_TERM_THRUSTER = 490,
        P221K01_CHAMBER_V2 = 491,

        P581_A01_BARREL_BIOHAZARD = 492,
        P581_A01_BARREL_BIOHAZARD_2 = 493,
        P581_A01_NUKE_BARREL = 494,
        P581_A01_RED_BARREL = 495,
        P581_A01_SIMPLE_BARREL = 496,
        P581_A01_SIMPLE_BARREL_2 = 497,
        BARREL_PROP_A = 498,
        BARREL_PROP_B = 499,
        BARREL_PROP_C = 500,
        CANNONBALL_CAPSULE_1 = 501,
        MISSILE_PACK01 = 502,
        MISSILE_PLAZMA01 = 503,
        MISSILE_STACK_BIOCHEM01 = 504,
        P581_A01_O2_BARREL = 505,
        NUCLEAR_WARHEAD_CLOSED = 506,
        NUCLEAR_WARHEAD_OPEN = 507,        
        P581_A01_NUKE_BARREL_1 = 508,
        P581_A01_SIMPLE_BARREL_3 = 509,
        P221L01_CHAMBER_V1 = 510,

        P221M01_CHAMBER_BOTTOM_V1 = 511,
        P221M01_CHAMBER_CENTER_V1 = 512,
        P221M01_CHAMBER_TOP_V1 = 513,
        P321E01_SOLAR_PANEL = 514,
        P110A06_SOLID_BEAM_STRAIGHT_420M = 515,

        GATTLING_AMMO_BELT = 516,
        MISSILE_PACK02 = 517,
        //BARREL_PROP_D = 518,
        //BARREL_PROP_E = 519,

        P311B01_CUT_THRUSTER = 520,
        P312B01_CUT_THRUSTER_LATERAL = 521,
        P312B02_CUT_THRUSTER_LATITUDE = 522,
        ALIEN_DETECTOR_UNIT = 523,
        P381_C01_BUILDING5 = 524,
        P381_C01_BUILDING6 = 525,
        P381_C01_BUILDING7 = 526,
        P221N01_CHAMBER_V1 = 527,
        P531_D_MEDIC_CROSS = 528,
        ALIEN_ARTEFACT = 529,
        BOMB = 530,
        RAIL_GUN = 531,
        P345_A01_RECYCLE_SPHERE = 532,
        PRISON = 533,
        P511_A17_BILLBOARD_PORTRAIT_1 = 534,
        P511_A18_BILLBOARD = 535,
        P511_A19_BILLBOARD = 536,
        //SOUNDS2 (do not use those numbers):
        //MOTHERSHIP_SOUND = 535,
        //MADELINE_MOTHERSHIP_SOUND = 536,

        DEAD_PILOT = 537,
        P511_A17_BILLBOARD_PORTRAIT_2 = 538,
    }


    public class MyMwcObjectBuilder_Prefab : MyMwcObjectBuilder_PrefabBase
    {
        [Obsolete("Changed to public for migration, set to internal when done")]
        public MyMwcObjectBuilder_Prefab()
            : base()
        {
        }

        public MyMwcObjectBuilder_Prefab(MyMwcObjectBuilder_Prefab_TypesEnum prefabType, MyMwcObjectBuilder_Prefab_AppearanceEnum appearance,
            MyMwcVector3Short position, Vector3 anglesInContainer, float? prefabMaxHealth, float prefabHealthRatio, string displayName, float electricCapacity, bool? causesAlarm, int aiPriority)
            : base((int)prefabType, appearance, position, anglesInContainer, prefabMaxHealth, prefabHealthRatio, displayName, electricCapacity, causesAlarm, aiPriority)
        {
        }

        public override MyMwcObjectBuilderTypeEnum GetObjectBuilderType()
        {
            return MyMwcObjectBuilderTypeEnum.Prefab;
        }

        public MyMwcObjectBuilder_Prefab_TypesEnum PrefabType
        {
            get
            {
                return (MyMwcObjectBuilder_Prefab_TypesEnum) GetObjectBuilderId().Value;
            }
            set
            {
                SetObjectBuilderId((int)value);
            }
        }

        //  Write this object into message-out
        internal override void Write(BinaryWriter binaryWriter)
        {
            base.Write(binaryWriter);

        }

        //  Read this object from message-in
        internal override bool Read(BinaryReader binaryReader, EndPoint senderEndPoint, int gameVersion)
        {
            if (base.Read(binaryReader, senderEndPoint, gameVersion) == false) return NetworkError();


            return true;
        }
    }
}
